//+------------------------------------------------------------------+
//|                                               Dolly Graphics.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//+------------------------------------------------------------------+
//|                                         Dolly (the famous sheep) |
//|               original indicator is called valasholic13 v2.5.mq4 |
//|                                                                  |
//|                  and the original author is valasholic@yahoo.com |
//|                                                                  |         
//|                        mods and stuff by Linuxser for Forex-TSD  |
//|                      (there is a lot of usefull code inside here)|
//|Credits: hulahula (traslation from original indonesian language)  |
//|ign... in collaboration with Linuxser (with mods and improvments  |
//+------------------------------------------------------------------+

/*
Changelog v0.4.1:
   - Modifications over the pivot points drawing: I think now is better
     and more clean code in that section. With this mod, also the
     pivots, supports and resistances are only calculated if and only
     if the flag pivotlines is set true.
     Other modifications here are about the object creation. With this
     improve the objects are created at init time and isn't necessary
     to create them at any time.
   - User experience: this is a conflictive point... I've modified some
     graphics issues to get a more readeable indicator.
       * "Unions" between zones of diferent days.
       * Realistic font size.
   - Corrections in the source coude... now it's a little more beauty (sorry for
     the little spanish comments)     
     
Changelog v0.4.2:
   - Comments modified (linuxser)
   - Added buy/sell zones just like the WSS indicator. (ign...)
   - Added a parameter to back to old style (without zones... ) Note: when
     the parameter ShowZones is off (false), then the objects are deleted to
     'improve' speed :) (ign...)
   - More improvements on PivotPoints add-on (object creation). (ign...)
   
*/
#property copyright ""
#property link      ""
#define Daily "Daily"
extern color DailyColor =Black;//C'0,50,0'C'06,20,55'//P/Buy area UP
#define Daily1 "Daily1"
extern color DailyColor1 =MidnightBlue;//C'8,44,44//Buy/BreakHigh 
#define Daily2 "Daily2"
extern color DailyColor2 =Blue;//C'6,99,11

#define Daily3 "Daily3"
extern color DailyColor3 =Black;//C'0,50,0//P/Sell area DN
#define Daily4 "Daily4"
extern color DailyColor4 =C'210,0,0';//C'8,44,44//Sell/BreakLow
#define Daily5 "Daily5"
extern color DailyColor5 =Red;//C'99,39,11

#define Daily6 "Daily6"
extern color DailyColor6 =C'255,80,0';//C'99,39,11
#define Daily7 "Daily7"
extern color DailyColor7 =C'0,80,255';//C'0,0,255


#define IND_NAME "Dolly v0.4.2"
#define LEVEL_1 20
#define LEVEL_2 40
#define LEVEL_3 55

#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  Snow
#property indicator_width1 0
#property indicator_color2  Red
#property indicator_width2 2
#property indicator_color3  Blue
#property indicator_width3 2
#property indicator_color4  Orange
#property indicator_width4 2
#property indicator_color5  SteelBlue
#property indicator_width5 2
#property indicator_color6  Yellow
#property indicator_width6 1
#property indicator_color7  Aqua
#property indicator_width7 1
//---- input parameters

extern bool ShowPivotLines = false;
extern bool ShowZones = false;
//extern int  BrokerGMTOffset = 0;
extern bool onscreen = true;
//extern bool dynamic = true;
//extern color lineletters = LimeGreen;

//---- buffers
double PBuffer[];
double J1Buffer[];
double B1Buffer[];
double J2Buffer[];
double B2Buffer[];
double J3Buffer[];
double B3Buffer[];
string Pivot = "Pivot Point", Jual1 = "S 1", Beli1 = "R 1";
string Jual2="S 2", Beli2="R 2", Jual3="S 3", Beli3="R 3";
extern int fontsize = 8;
double P, J1, B1, J2, B2, J3, B3;
double LastHigh, LastLow, x;
double D4=0.55;

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(0,OBJ_HLINE);
   ObjectsDeleteAll(0,OBJ_TEXT);
   ObjectsDeleteAll(0,OBJ_RECTANGLE);
   
   /*ObjectDelete(Daily);
   ObjectDelete(DailyColor);
   ObjectDelete(Daily1);
   ObjectDelete(DailyColor1);
   ObjectDelete(Daily2);
   ObjectDelete(DailyColor2);
   ObjectDelete(Daily3);
   ObjectDelete(DailyColor3);
   ObjectDelete(Daily4);
   ObjectDelete(DailyColor4);
   ObjectDelete(Daily5);
   ObjectDelete(DailyColor5);
   ObjectDelete(Daily6);
   ObjectDelete(DailyColor6);
   ObjectDelete(Daily7);
   ObjectDelete(DailyColor7);*/
   
   ObjectDelete("Pivot");
   ObjectDelete("Jual1");
   ObjectDelete("Beli1");
   ObjectDelete("Jual2");
   ObjectDelete("Beli2");
   ObjectDelete("Jual3");
   ObjectDelete("Beli3");   


         if(ObjectFind("BuyStop")==0)
            ObjectDelete("BuyStop");
         if(ObjectFind("SellStop")==0)
            ObjectDelete("SellStop");
         Comment("");
  	deinit_pivots();
	deinit_zones();
	//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	//---- indicator line
	SetIndexStyle(0, DRAW_LINE,STYLE_DOT);
	SetIndexStyle(1, DRAW_NONE);
	SetIndexStyle(2, DRAW_NONE);
	SetIndexStyle(3, DRAW_NONE);
	SetIndexStyle(4, DRAW_NONE);
	SetIndexStyle(5, DRAW_NONE);
	SetIndexStyle(6, DRAW_NONE);
	SetIndexBuffer(0, PBuffer);
	SetIndexBuffer(1, J1Buffer);
	SetIndexBuffer(2, B1Buffer);
	SetIndexBuffer(3, J2Buffer);
	SetIndexBuffer(4, B2Buffer);
	SetIndexBuffer(5, J3Buffer);
	SetIndexBuffer(6, B3Buffer);
	//---- name for DataWindow and indicator subwindow label
	IndicatorShortName(IND_NAME);
	//SetIndexLabel(0, "Pivot Point");
	//----
	SetIndexDrawBegin(0,1);
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

	/*ObjectCreate("Pivot", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Pivot", "                            PIVOT/SL+SP", fontsize, "Arial", Silver);
	ObjectCreate("Jual1", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Jual1", "                        SELL AREA", fontsize, "Arial", Orange);
	ObjectCreate("Beli1", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Beli1", "                        BUY AREA", fontsize, "Arial", DodgerBlue);
	ObjectCreate("Jual2", OBJ_TEXT, 0, 0, 0); 
	ObjectSetText("Jual2", "                                   1st SELL TARGET ", fontsize, "Arial",Orange);
	ObjectCreate("Beli2", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Beli2", "                                1st BUY TARGET", fontsize, "Arial", DodgerBlue);
	ObjectCreate("Jual3", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Jual3", "                           2nd TARGET", fontsize, "Arial", Orange);
	ObjectCreate("Beli3", OBJ_TEXT, 0, 0, 0); 
	ObjectSetText("Beli3", "                           2nd TARGET", fontsize, "Arial", DodgerBlue);*/
   

   
   if(ShowPivotLines)
      init_pivots();
      
   if(ShowZones)
      init_zones();
	//----
	return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
  CreateHL();
}

void CreateObj(string objName, double start, double end, color clr)
{
   ObjectCreate(objName, OBJ_RECTANGLE, 0, iTime(NULL,1440,0), start, Time[0], end);
   ObjectSet(objName, OBJPROP_COLOR, clr);
   
}
void DeleteObjects()
{
   /*ObjectDelete(Daily);
   ObjectDelete(DailyColor);
   ObjectDelete(Daily1);
   ObjectDelete(DailyColor1);
   ObjectDelete(Daily2);
   ObjectDelete(DailyColor2);
   ObjectDelete(Daily3);
   ObjectDelete(DailyColor3);
   ObjectDelete(Daily4);
   ObjectDelete(DailyColor4);
   ObjectDelete(Daily5);
   ObjectDelete(DailyColor5);
   ObjectDelete(Daily6);
   ObjectDelete(DailyColor6);
   ObjectDelete(Daily7);
   ObjectDelete(DailyColor7);*/
   
}
void CreateHL()
{
  DeleteObjects();
  double OPEN = iOpen(NULL,1440,0); 
  double HI2 = iHigh(NULL,1440,0);
  double LOW2 = iLow(NULL,1440,0); 
  double HI3 = iHigh(NULL,1440,1);
  double LOW3 = iLow(NULL,1440,1);
  double HI4 = iHigh(NULL,1440,0);
  double LOW4 = iLow(NULL,1440,0);
  double HI5 = iHigh(NULL,1440,2);
  double LOW5 = iLow(NULL,1440,2);
  double HI6 = iHigh(NULL,1440,3);
  double LOW6 = iLow(NULL,1440,3);
  double HI7 = iHigh(NULL,1440,4);
  double LOW7 = iLow(NULL,1440,4);
  double HI8 = iHigh(NULL,1440,5);
  double LOW8 = iLow(NULL,1440,5);
  double HI9 = iHigh(NULL,1440,6);
  double LOW9 = iLow(NULL,1440,6);
  double HI10 = iHigh(NULL,1440,7);
  double LOW10 = iLow(NULL,1440,7);
  double HI11 = iHigh(NULL,1440,8);
  double LOW11 = iLow(NULL,1440,8);
  double HI12 = iHigh(NULL,1440,9);
  double LOW12 = iLow(NULL,1440,9);
  double HI13 = iHigh(NULL,1440,10);
  double LOW13 = iLow(NULL,1440,10);
  double HI14 = iHigh(NULL,1440,11);
  double LOW14 = iLow(NULL,1440,11);
  double HI15 = iHigh(NULL,1440,12);
  double LOW15 = iLow(NULL,1440,12);
  double HI16 = iHigh(NULL,1440,13);
  double LOW16 = iLow(NULL,1440,13);
  double HI17 = iHigh(NULL,1440,14);
  double LOW17 = iLow(NULL,1440,14);
  double HI18 = iHigh(NULL,1440,15);
  double LOW18 = iLow(NULL,1440,15);
  double HI19 = iHigh(NULL,1440,16);
  double LOW19 = iLow(NULL,1440,16);
  double HI20 = iHigh(NULL,1440,17);
  double LOW20 = iLow(NULL,1440,17);
  double HI21 = iHigh(NULL,1440,18);
  double LOW21 = iLow(NULL,1440,18);
  double HI22 = iHigh(NULL,1440,19);
  double LOW22 = iLow(NULL,1440,19);
  double HI23 = iHigh(NULL,1440,20);
  double LOW23 = iLow(NULL,1440,20);
     
  double ONE = (HI3-LOW3)/2;
  
  double FIVE = ((HI3-LOW3)+(HI5-LOW5)+(HI6-LOW6)+(HI7-LOW7)+(HI8-LOW8))/10;
           
  double TEN = ((HI3-LOW3)+(HI5-LOW5)+(HI6-LOW6)+(HI7-LOW7)+(HI8-LOW8)+
                  (HI9-LOW9)+(HI10-LOW10)+(HI11-LOW11)+(HI12-LOW12)+(HI13-LOW13))/20;
                    
  double TWENTY = ((HI3-LOW3)+(HI5-LOW5)+(HI6-LOW6)+(HI7-LOW7)+(HI8-LOW8)+
               (HI9-LOW9)+(HI10-LOW10)+(HI11-LOW11)+(HI12-LOW12)+(HI13-LOW13)+
               (HI14-LOW14)+(HI15-LOW15)+(HI16-LOW16)+(HI17-LOW17)+(HI18-LOW18)+
               (HI19-LOW19)+(HI20-LOW20)+(HI21-LOW21)+(HI22-LOW22)+(HI23-LOW23))/40; 
                                              
  double AV = (ONE+FIVE+TEN+TWENTY)/4;// New Setting AV = (FIVE+TEN+TWENTY)/3;
  
  double HIDaily = P; 
  double LOWDaily =B1; 
  double HIDaily1 = B2; 
  double LOWDaily1 =B1; 
  double HIDaily2 = B2; 
  double LOWDaily2 =B3;
  double HIDaily3 = P; 
  double LOWDaily3 =J1; 
  double HIDaily4 = J2; 
  double LOWDaily4 =J1; 
  double HIDaily5 = J2; 
  double LOWDaily5 =J3; 
  double HIDaily6 = J3; 
  double LOWDaily6 =OPEN-AV*2; 
  double HIDaily7 = OPEN+AV*2; 
  double LOWDaily7 = B3; 
  
  
  double CLOSE = iClose(NULL,1440,0);
  ObjectDelete("Pivot");
  /*if(ObjectFind("Pivot") != 0)
   {
      ObjectCreate("Pivot", OBJ_TEXT, 0, Time[0], HIDaily);
      ObjectSetText("Pivot", "                             PIVOT/SL+SP", 8, "Arial", Silver);
   }
   else
   {
      ObjectMove("Pivot", 0, Time[0], HIDaily);
   }
   if(ObjectFind("Jual1") != 0)
   {
      ObjectCreate("Jual1", OBJ_TEXT, 0, Time[0], LOWDaily3);
      ObjectSetText("Jual1", "                         SELL AREA", 8, "Arial", Orange);
   }
   else
   {
      ObjectMove("Jual1", 0, Time[0], LOWDaily3);
   } 
	  
   if(ObjectFind("Beli1") != 0)
   {
      ObjectCreate("Beli1", OBJ_TEXT, 0, Time[0], LOWDaily);
      ObjectSetText("Beli1", "                        BUY AREA", 8, "Arial",DodgerBlue);
   }
   else
   {
      ObjectMove("Jual2", 0, Time[0], LOWDaily);
   }
   if(ObjectFind("Jual2") != 0)
{
ObjectCreate("Jual2", OBJ_TEXT, 0, Time[0], HIDaily4);
ObjectSetText("Jual2", "                                   1st SELL TARGET ", 8, "Arial",Orange);
}
else
{
ObjectMove("Jual2", 0, Time[0], HIDaily4);
}	
     if(ObjectFind("Beli2") != 0)
{
ObjectCreate("Beli2", OBJ_TEXT, 0, Time[0], HIDaily1);
ObjectSetText("Beli2", "                                   1st BUY TARGET ", 8, "Arial",DodgerBlue);
}
else
{
ObjectMove("Beli2", 0, Time[0], HIDaily1);
}	
     if(ObjectFind("Jual3") != 0)
{
ObjectCreate("Jual3", OBJ_TEXT, 0, Time[0], LOWDaily5);
ObjectSetText("Jual3", "                             2nd TARGET ", 8, "Arial",Orange);
}
else
{
ObjectMove("Jual3", 0, Time[0], LOWDaily5);
}	
     if(ObjectFind("Beli3") != 0)
{
ObjectCreate("Beli3", OBJ_TEXT, 0, Time[0], LOWDaily2);
ObjectSetText("Beli3", "                             2nd TARGET ", 8, "Arial",DodgerBlue);
}
else
{
ObjectMove("Beli3", 0, Time[0], LOWDaily2);
}	


     if(ObjectFind("TOP/AV") != 0)
{
ObjectCreate("TOP/AV", OBJ_TEXT, 0, Time[0], HIDaily7);
ObjectSetText("TOP/AV", "                                     TOP DAILY RANGE", 8, "Arial", DodgerBlue);
}
else
{
ObjectMove("TOP/AV", 0, Time[0], HIDaily7);
} 
  
     if(ObjectFind("LOW/AV") != 0)
{
ObjectCreate("LOW/AV", OBJ_TEXT, 0, Time[0], LOWDaily6);
ObjectSetText("LOW/AV", "                                     LOW DAILY RANGE", 8, "Arial", Orange);
}
else
{
ObjectMove("LOW/AV", 0, Time[0], LOWDaily6);
} 

  
  //double HID = iHigh(NULL,1440,0)-(AV);
  //double LOWD = iLow(NULL,1440,0)+(AV);
   ObjectsRedraw();
   CreateObj(Daily, HIDaily, LOWDaily, DailyColor);
   CreateObj(Daily1, HIDaily1, LOWDaily1, DailyColor1);
   CreateObj(Daily2, HIDaily2, LOWDaily2, DailyColor2);
   CreateObj(Daily3, HIDaily3, LOWDaily3, DailyColor3);
   CreateObj(Daily4, HIDaily4, LOWDaily4, DailyColor4);
   CreateObj(Daily5, HIDaily5, LOWDaily5, DailyColor5);
   CreateObj(Daily6, HIDaily6, LOWDaily6, DailyColor6);
   CreateObj(Daily7, HIDaily7, LOWDaily7, DailyColor7);*/
 
  

	int counted_bars = IndicatorCounted();
	int limit, i;

	//---- indicator calculation
	if(counted_bars == 0)
	{
		x = Period();
		if(x > 240) 
			return(-1);

		///////////To Make a Line for SELL/BUY \\\\\\\\\\\\\

	}
	if(counted_bars < 0) 
		return(-1);
	//---- last counted bar will be recounted
	//   if(counted_bars>0) counted_bars--;
	limit = (Bars - counted_bars) - 1;
	//----
	for(i = limit; i >= 0; i--)
	{ 
		if(High[i+1] > LastHigh) 
			LastHigh = High[i+1];
		//----
		if(Low[i+1] < LastLow) 
			LastLow=Low[i+1];
		if(TimeDay(Time[i]) != TimeDay(Time[i+1]))
		{
		   PBuffer[i+1] = EMPTY_VALUE;
		   J1Buffer[i+1] = EMPTY_VALUE;
		   B1Buffer[i+1] = EMPTY_VALUE;
		   J2Buffer[i+1] = EMPTY_VALUE;
		   B2Buffer[i+1] = EMPTY_VALUE;
		   J3Buffer[i+1] = EMPTY_VALUE;
		   B3Buffer[i+1] = EMPTY_VALUE;
			//////////// Logic for determinate Momentum Break \\\\\\\\\\\\\\\\\\\\\

			P = (LastHigh + LastLow + Close[i+1]) / 3; // Logic for determinating pivot
			B1 = P + LEVEL_1 * Point; // Logic to determinate Buy Area (Can be change as you analize)
			J1 = P - LEVEL_1 * Point; // Logic to determinate Sell Area (Can be change as you analize)
			B2 = P + LEVEL_2 * Point; // Logic to determinate High Break Area (Can be change as you analize)
			J2 = P - LEVEL_2 * Point; // Logic to determinate Low Break Area (Can be change as you analize)
			B3 = P + LEVEL_3 * Point; // Logic to determinate High Target Area (Can be change as you analize)
			J3 = P - LEVEL_3 * Point; // Logic to determinate Low Target Area (Can be change as you analize)
			
			//Lo usa para calcular los pivotes... no deberia ser Low[] y High[]???
			LastLow = Open[i]; 
			LastHigh = Open[i];
			
        /* ObjectMove("Pivot", 0, Time[0], P);
         ObjectMove("Jual1", 0, Time[0], J1);
         ObjectMove("Beli1", 0, Time[0], B1);
         ObjectMove("Jual2", 0, Time[0], J2);
         ObjectMove("Beli2", 0, Time[0], B2);
         ObjectMove("Jual3", 0, Time[0], J3);
         ObjectMove("Beli3", 0, Time[0], B3);*/
         
         if( ShowZones && TimeDayOfYear(Time[i]) == DayOfYear())
         {
            if( ObjectFind("Neutral_0") == -1 )
               init_zones();
            move_zones(i, J1, J2, J3, B1,B2, B3);
         }
		}
		PBuffer[i] = P;
		J1Buffer[i] = J1;
		B1Buffer[i] = B1;
		J2Buffer[i] = J2;
		B2Buffer[i] = B2;
		J3Buffer[i] = J3;
		B3Buffer[i] = B3;



		if (ShowPivotLines==true)
		{
		    //---- Saca maximos y minimos para calcular los pivotes.
		    //-- Despues tengo que leer bien esto ya que es lo que se deberia usar en un principio
		    double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
		    ArrayCopyRates(rates, Symbol(), PERIOD_D1);

		    if(DayOfWeek() == 1)
		    {
			    if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
			    {
				    yesterday_close = rates[1][4];
				    yesterday_high = rates[1][3];
				    yesterday_low = rates[1][2];
			    }
			    else
			    {
				    for(int d = 5;d>=0;d--)
				    {
					    if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
					    {
						    yesterday_close = rates[d][4];
						    yesterday_high = rates[d][3];
						    yesterday_low = rates[d][2];
						    break;
					    }
				    }  
			    }
		    }
		    else
		    {
			    yesterday_close = rates[1][4];
			    yesterday_high = rates[1][3];
			    yesterday_low = rates[1][2];
		    }
			//---- Calculate Pivots
			double R = yesterday_high - yesterday_low;//range
			double p = ( yesterday_high + yesterday_low + yesterday_close ) / 3;// Standard Pivot
			double r3 = ( 2 * p ) + ( yesterday_high - ( 2 * yesterday_low ));
			double r2 = p + ( yesterday_high - yesterday_low );
			double r1 = ( 2 * p ) - yesterday_low;
			double s1 = ( 2 * p ) - yesterday_high;
			double s2 = p - ( yesterday_high - yesterday_low );
			double s3 = ( 2 * p ) - ( ( 2 * yesterday_high ) - yesterday_low );

         if(ObjectFind("p_Line") == -1)
            init_pivots();
         set_pivots(p, r1, r2, r3, s1, s2, s3);
		}

	


		//HOW TO MAKE THE PRICE LINE OF THE SUPPORT & RESISTANT APPEAR?
		//WAITING FOR NEXT TIP & UP DATE


	}
   	string symb=Symbol();
   	if (onscreen==true) 
         
			Comment (
			       "\n        " + IND_NAME + " ( BREAKOUT STRATEGY ) "
					+"\n -------------------------------------------------------------------"
					+"\n BUY AREA (break) :"
					+"\n -------------------------------------------------------------------"
					+"\n FIRST BUY STOP  "+symb+" TO "+(DoubleToStr (B1Buffer[0],Digits))
					+"\n SECOND BUY STOP  "+symb+" TO "+(DoubleToStr(B2Buffer[0],Digits))					
					+"\n STOP LOSS Conservative "+(DoubleToStr (PBuffer[0]-(6*Point),Digits))
					+"\n STOP LOSS Risky "+(DoubleToStr(B1Buffer[0],Digits))	
					+"\n INITIAL TAKE PROFIT "+(DoubleToStr ((B2Buffer[0]),Digits))
					+"\n SECONDARY TAKE PROFIT "+(DoubleToStr ((B3Buffer[0]),Digits))
					+"\n "
					+"\n -------------------------------------------------------------------"
					+"\n \n SELL AREA (break) :"
					+"\n -------------------------------------------------------------------"
					+"\n FIRST SELL STOP  "+symb+" TO "+(DoubleToStr (J1Buffer[0],Digits))					
					+"\n SECOND SELL STOP  "+symb+" TO "+(DoubleToStr (J2Buffer[0],Digits))
					+"\n STOP LOSS Conservative"+(DoubleToStr (PBuffer[0]+(6*Point),Digits))
					+"\n STOP LOSS Risky"+(DoubleToStr(B1Buffer[0],Digits))		
					+"\n INITIAL TAKE PROFIT "+(DoubleToStr ((J2Buffer[0]),Digits))
					+"\n SECONDARY TAKE PROFIT "+(DoubleToStr ((J3Buffer[0]),Digits))
					+"\n "			
					+"\n -------------------------------------------------------------------"
					+"\n POSSIBLE PROJECTIONS AND REVERSAL LEVELS "
					+"\n (USE WITH CAUTION) "
					+"\n -------------------------------------------------------------------"
					+"\n LOWER CORRECTION :"
					+"\n # TARGET/BUY LIMIT  "+symb+" TO "+(DoubleToStr(PBuffer[0]-(89*Point),Digits))
					+"\n # TARGET/BUY LIMIT  "+symb+" TO "+(DoubleToStr(PBuffer[0]-(144*Point),Digits))					
					+"\n \n UPPER CORRECTION :"
					+"\n # TARGET/SELL LIMIT  "+symb+" TO "+(DoubleToStr(PBuffer[0]+(89*Point),Digits))
					+"\n # TARGET/SELL LIMIT  "+symb+" TO "+(DoubleToStr(PBuffer[0]+(144*Point),Digits))					
					+"\n -------------------------------------------------------------------"
					+"\n OPEN   "+symb+"   "+(DoubleToStr(OPEN,Digits))
					+"\n DAILY AVERAGE RANGE  "+symb+"   "+(DoubleToStr(AV*2,Digits))
					+"\n TOTAL PIPS HI TO LOW  "+symb+"   "+(DoubleToStr(HI2-LOW2,Digits))
					+"\n"
					+"\n TOP DAILY RANGE   "+symb+"   "+(DoubleToStr(OPEN+AV*2,Digits))
					+"\n LOW DAILY RANGE  "+symb+"   "+(DoubleToStr(OPEN-AV*2,Digits))
					+"\n -------------------------------------------------------------------"
					);
					 if(ObjectFind("BuyStop")==-1)
                {
                     ObjectCreate("BuyStop",OBJ_TREND,0,Time[0],B1Buffer[0],Time[7],B1Buffer[0]);
                     ObjectSet("BuyStop",OBJPROP_COLOR,Yellow);
                     ObjectSet("BuyStop",OBJPROP_WIDTH,1);
                     ObjectSet("BuyStop",OBJPROP_STYLE,STYLE_DOT);
                     ObjectSet("BuyStop",OBJPROP_RAY,false);
                }
                else
                {  
                     ObjectSet("BuyStop",OBJPROP_TIME1,Time[0]);
                     ObjectSet("BuyStop",OBJPROP_PRICE1,B1Buffer[0]);
                     ObjectSet("BuyStop",OBJPROP_TIME2,Time[7]);
                     ObjectSet("BuyStop",OBJPROP_PRICE2,B1Buffer[0]);
                     ObjectSet("BuyStop",OBJPROP_COLOR,Yellow);
                     ObjectSet("BuyStop",OBJPROP_STYLE,STYLE_DOT);
                }
                
                if(ObjectFind("SellStop")==-1)
                {
                     ObjectCreate("SellStop",OBJ_TREND,0,Time[0],J1Buffer[0],Time[7],J1Buffer[0]);
                     ObjectSet("SellStop",OBJPROP_COLOR,Red);
                     ObjectSet("SellStop",OBJPROP_WIDTH,1);
                     ObjectSet("SellStop",OBJPROP_STYLE,STYLE_DOT);
                     ObjectSet("SellStop",OBJPROP_RAY,false);
                }
                else
                {  
                     ObjectSet("SellStop",OBJPROP_TIME1,Time[0]);
                     ObjectSet("SellStop",OBJPROP_PRICE1,J1Buffer[0]);
                     ObjectSet("SellStop",OBJPROP_TIME2,Time[7]);
                     ObjectSet("SellStop",OBJPROP_PRICE2,J1Buffer[0]);
                     ObjectSet("SellStop",OBJPROP_COLOR,Red);
                     ObjectSet("SellStop",OBJPROP_STYLE,STYLE_DOT);
                }
	//----
	return(0);

}
//+------------------------------------------------------------------+

void init_pivots()
{
	ObjectCreate("p_Line", OBJ_HLINE,0, 0,0);
	ObjectSet("p_Line",OBJPROP_COLOR,DeepPink);
	ObjectSet("p_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("r1_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("r1_Line",OBJPROP_COLOR,Yellow);
	ObjectSet("r1_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("r2_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("r2_Line",OBJPROP_COLOR,Orange);
	ObjectSet("r2_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("r3_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("r3_Line",OBJPROP_COLOR,Red);
	ObjectSet("r3_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("s1_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("s1_Line",OBJPROP_COLOR,Yellow);
	ObjectSet("s1_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("s2_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("s2_Line",OBJPROP_COLOR,Orange);
	ObjectSet("s2_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("s3_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("s3_Line",OBJPROP_COLOR,Red);
	ObjectSet("s3_Line",OBJPROP_STYLE,STYLE_SOLID);

	// --- Typing Labels
	if(ObjectFind("R3 label") != 0)
	{
		ObjectCreate("R3 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("R3 label", " R3 ", 8, "Arial", Red);
	}

	if(ObjectFind("S3 label") != 0)
	{
		ObjectCreate("S3 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("S3 label", " S3 ", 8, "Arial", Red);
	}

	if(ObjectFind("R2 label") != 0)
	{
		ObjectCreate("R2 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("R2 label", " R2 ", 8, "Arial", Orange);
	}

	if(ObjectFind("S2 label") != 0)
	{
		ObjectCreate("S2 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("S2 label", " S2 ", 8, "Arial", Orange);
	}

	if(ObjectFind("R1 label") != 0)
	{
		ObjectCreate("R1 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("R1 label", " R1 ", 8, "Arial", Yellow);
	}

	if(ObjectFind("S1 label") != 0)
	{
		ObjectCreate("S1 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("S1 label", " S1 ", 8, "Arial", Yellow);
	}

	if(ObjectFind("P label") != 0)
	{
		ObjectCreate("P label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("P label", " Pivot ", 8, "Arial", DeepPink);
	}
	return;
}

void set_pivots(double p, double r1, double r2, double r3, double s1, double s2, double s3)
{
   ObjectSet("p_Line",OBJPROP_PRICE1, p);   ObjectMove("P label",  0, Time[0], p);
   ObjectSet("r1_Line",OBJPROP_PRICE1, r1); ObjectMove("R1 label", 0, Time[0], r1);
   ObjectSet("r2_Line",OBJPROP_PRICE1, r2); ObjectMove("R2 label", 0, Time[0], r2);
   ObjectSet("r3_Line",OBJPROP_PRICE1, r3); ObjectMove("R3 label", 0, Time[0], r3);
   ObjectSet("s1_Line",OBJPROP_PRICE1, s1); ObjectMove("S1 label", 0, Time[0], s1);
   ObjectSet("s2_Line",OBJPROP_PRICE1, s2); ObjectMove("S2 label", 0, Time[0], s2);
   ObjectSet("s3_Line",OBJPROP_PRICE1, s3); ObjectMove("S3 label", 0, Time[0], s3);
   
}

void deinit_pivots()
{
	ObjectDelete("r1 Label");
	ObjectDelete("r1_Line");
	ObjectDelete("r2 Label");
	ObjectDelete("r2_Line");
	ObjectDelete("r3 Label");
	ObjectDelete("r3_Line");
	ObjectDelete("r1 Label");
	ObjectDelete("r1_Line");
	ObjectDelete("r2 Label");
	ObjectDelete("r2_Line");
	ObjectDelete("r3 Label");
	ObjectDelete("r3_Line");
	ObjectDelete("R1 Label");
	ObjectDelete("R1_Line");
	ObjectDelete("R2 Label");
	ObjectDelete("R2_Line");
	ObjectDelete("R3 Label");
	ObjectDelete("R3_Line");
	ObjectDelete("S1 Label");
	ObjectDelete("S1_Line");
	ObjectDelete("S2 Label");
	ObjectDelete("S2_Line");
	ObjectDelete("S3 Label");
	ObjectDelete("S3_Line");
	ObjectDelete("P Label");
	ObjectDelete("P_Line");
}

void
init_zones()
{
   int i;
   for(i = 0; i < (LEVEL_1 *2 /2); i++)
   {
      ObjectCreate( "Neutral_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Neutral_"+i, OBJPROP_COLOR, White);
      ObjectSet("Neutral_"+i, OBJPROP_WIDTH, 1);
   }
   
   for(i = 0; i < (LEVEL_2 / 2); i++)
   {
      ObjectCreate( "Buy1_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Buy1_"+i, OBJPROP_COLOR, Blue);
      ObjectSet("Buy1_"+i, OBJPROP_WIDTH, 1);
      
      ObjectCreate( "Sell1_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Sell1_"+i, OBJPROP_COLOR, Red);
      ObjectSet("Sell1_"+i, OBJPROP_WIDTH, 1);
   }
   
   for(i = 0; i < (LEVEL_2 *2 /2); i++)
   {
      ObjectCreate( "Buy2_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Buy2_"+i, OBJPROP_COLOR, SteelBlue);
      ObjectSet("Buy2_"+i, OBJPROP_WIDTH, 1);
      
      ObjectCreate( "Sell2_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Sell2_"+i, OBJPROP_COLOR, Orange);
      ObjectSet("Sell2_"+i, OBJPROP_WIDTH, 1);
   }
}

void // J's < B's
move_zones(int time, double J1, double J2, double J3, double B1, double B2, double B3)
{
   int periods_by_day = (60*24)/ Period();
   int i, obj_num;
   
   for(i = 0; i < (B1 - J1) / Point; i += 2)
   {
      obj_num = i / 2;
      
      ObjectSet("Neutral_"+obj_num, OBJPROP_PRICE1, J1 + i * Point);
      ObjectSet("Neutral_"+obj_num, OBJPROP_PRICE2, J1 + i * Point);
      ObjectSet("Neutral_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Neutral_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Neutral_"+obj_num, OBJPROP_BACK, true);
   }
   
   for(i = 0; i < (J1 - J2) / Point; i += 2)
   {
      obj_num = i / 2;
      
      ObjectSet("Buy1_"+obj_num, OBJPROP_PRICE1, B1 + i * Point);
      ObjectSet("Buy1_"+obj_num, OBJPROP_PRICE2, B1 + i * Point);
      ObjectSet("Buy1_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Buy1_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Buy1_"+obj_num, OBJPROP_BACK, true);
      
      ObjectSet("Sell1_"+obj_num, OBJPROP_PRICE1, J1 - i * Point);
      ObjectSet("Sell1_"+obj_num, OBJPROP_PRICE2, J1 - i * Point);
      ObjectSet("Sell1_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Sell1_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Sell1_"+obj_num, OBJPROP_BACK, true);
   }
   
   for(i = 0; i < (J2 - J3) / Point; i += 2)
   {
      obj_num = i / 2;
      
      ObjectSet("Buy2_"+obj_num, OBJPROP_PRICE1, B2 + i * Point);
      ObjectSet("Buy2_"+obj_num, OBJPROP_PRICE2, B2 + i * Point);
      ObjectSet("Buy2_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Buy2_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Buy2_"+obj_num, OBJPROP_BACK, true);
      
      ObjectSet("Sell2_"+obj_num, OBJPROP_PRICE1, J2 - i * Point);
      ObjectSet("Sell2_"+obj_num, OBJPROP_PRICE2, J2 - i * Point);
      ObjectSet("Sell2_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Sell2_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Sell2_"+obj_num, OBJPROP_BACK, true);
   }
}

void
deinit_zones()
{
   int i;
   for(i = 0; i < (LEVEL_1 *2 /2); i++)
      ObjectDelete( "Neutral_"+i);
 
   
   for(i = 0; i < (LEVEL_2 / 2); i++)
   {
      ObjectDelete( "Buy1_"+i);
      ObjectDelete( "Sell1_"+i);

   }
   
   for(i = 0; i < (LEVEL_2 *2 /2); i++)
   {
      ObjectDelete( "Buy2_"+i);
      ObjectDelete( "Sell2_"+i);
   }
}